/*
    $Id: frames.h,v 1.3 2001/11/01 20:55:50 sensei Exp $

    Copyright (C) 2000-2001  Marko Zivanovic
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef FRAMES_H

#include <sys/socket.h>
#include <linux/if_ether.h>
#include <linux/ip.h>
#include <linux/tcp.h>
#include <linux/udp.h>
#include <linux/icmp.h>

/*  NOTE:                                                           */
/*  - length is the total length of the structure (headers + time + */
/*  					       length field)        */
typedef struct {
  time_t time;
  int length;
  struct ethhdr eth;
  struct iphdr  ip;
  char data[8192];
} eth_ip_frame;

typedef struct {
  time_t time;
  int length;
  struct ethhdr eth;
  struct iphdr  ip;
  struct tcphdr tcp;
  char data[8192];
} eth_ip_tcp_frame;

typedef struct {
  time_t time;
  int length;
  struct ethhdr eth;
  struct iphdr  ip;
  struct udphdr udp;
  char data[8192];
} eth_ip_udp_frame;

typedef struct {
  time_t time;
  int length;
  struct ethhdr  eth;
  struct iphdr   ip;
  struct icmphdr icmp;
  char data[8192];
} eth_ip_icmp_frame;

typedef struct {
  u_int8_t reserved:1;
  u_int8_t df:1;
  u_int8_t mf:1;
  u_int16_t frag_off;
} ip_flags;

#define FRAMES_H
#endif







