/*
    $Id: scripting.h,v 1.5 2001/11/01 20:55:50 sensei Exp $

    Copyright (C) 2000-2001  Marko Zivanovic
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef _USE_SCRIPTING_H_

#include "../config.h"

#include <stdlib.h>
#include <tcl.h>
#include <ctype.h>

#include "log.h"
#include "config.h"
#include "frames.h"
#include "helper.h"

int S_load_script (char*);
int S_on_initialize (void);
int S_on_shutdown (void);
int S_on_receive_packet (eth_ip_frame*);
int S_on_dump_packet (eth_ip_frame*);
int S_on_start_sniffing (void);

int S_set_str_var (char*, char*);
int S_set_int_var (char*, int);
char* S_get_str_var (char*);
int S_get_int_var (char*);
int S_hex_dump (char*, char*, int);
int S_ascii_dump (char*, char*, int);

int S_load_all_headers (eth_ip_frame*);
int S_load_packet_info (eth_ip_frame*);
int S_load_eth_hdr (eth_ip_frame*);
int S_load_ip_hdr (eth_ip_frame*);
int S_load_icmp_hdr (eth_ip_icmp_frame*);
int S_load_tcp_hdr (eth_ip_tcp_frame*);
int S_load_udp_hdr (eth_ip_udp_frame*);

char* S_getErrorInfo ();

/*  ************************************************************ */
/*  custom functions inserted into script interpreter            */
/*  ************************************************************ */

typedef int S_cmdProc (ClientData cd, Tcl_Interp* S_int,
		       int argc, char *argv[]);

extern int sock;
extern void promisc_on (int, char*);
extern void promisc_off (int, char*);

int S_load_cmds (void);
int S_promiscOn (ClientData, Tcl_Interp*, int, char**);
int S_promiscOff (ClientData, Tcl_Interp*, int, char**);

/* scripting engine */
extern Tcl_Interp *S_int;

#define _USE_SCRIPTING_H_
#endif

